
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>linux下nginx模块开发入门 / 憋错料</title>

    <meta name="description" content="linux下nginx模块开发入门 本文模块编写参考http://blog.codinglabs.org/articles/intro-of-nginx-module-development.html 之前讲了nginx的安装,算是对nginx有了最初步的了解,在配置完之后,我们就可以进行简单的nginx模块开发了. 下面本文展示一个简单的Nginx模块开发全过程,我们开发一个叫echo的handler模块,这个模块功能非常简单,它接收“echo”指令,指令可指定一个字符串参数,模块会输出这个字符串作为HTTP响应.例如,对ngi">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">linux下nginx模块开发入门</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>本文模块编写参考<a href="http://blog.codinglabs.org/articles/intro-of-nginx-module-development.html" rel="external nofollow noreferrer">http://blog.codinglabs.org/articles/intro-of-nginx-module-development.html</a></p>
<p>之前讲了nginx的安装,算是对nginx有了最初步的了解,在配置完之后,我们就可以进行简单的nginx模块开发了.</p>
<p>下面本文展示一个简单的Nginx模块开发全过程，我们开发一个叫echo的handler模块，这个模块功能非常简单，它接收&ldquo;echo&rdquo;指令，指令可指定一个字符串参数，模块会输出这个字符串作为HTTP响应。例如，对nginx.conf做如下配置：</p>
<pre>location /echo {
    echo "hello";
}</pre>
<p>则访问<a href="http://hostname/echo" rel="external nofollow noreferrer">http://hostname/echo</a>时会输出hello nginx。</p>
<p>要实现这个功能需要三步：<strong>1、读入配置文件中echo指令及其参数；2、进行HTTP包装（添加HTTP头等工作）；3、将结果返回给客户端</strong>。下面本文将分部介绍整个模块的开发过程。</p>
<p>对编写模块过程没兴趣的，只想了解如何加载模块可以直接跳到这里</p>
<h2>定义模块配置结构</h2>
<p>首先我们需要一个结构用于存储从配置文件中读进来的相关指令参数，即模块配置信息结构。根据Nginx模块开发规则，这个结构的命名规则为ngx_http_[module-name]_[main|srv|loc]_conf_t。其中main、srv和loc分别用于表示同一模块在三层block中的配置信息。这里我们的echo模块只需要运行在loc层级下，需要存储一个字符串参数，因此我们可以定义如下的模块配置：</p>
<pre>typedef struct {
　　ngx_str_t ed;
} ngx_http_echo_loc_conf_t;</pre>
<p>其中字段ed用于存储echo指令指定的需要输出的字符串。注意这里ed的类型，在Nginx模块开发中使用ngx_str_t类型表示字符串，这个类型定义在core/ngx_string中：</p>
<pre>typedef struct {
　　size_t len;
　　u_char *data;
} ngx_str_t;</pre>
<p>其中两个字段分别表示字符串的长度和数据起始地址。注意在Nginx源代码中对数据类型进行了别称定义，如ngx_int_t为intptr_t的别称，为了保持一致，在开发Nginx模块时也应该使用这些Nginx源码定义的类型而不要使用C原生类型。除了ngx_str_t外，其它三个常用的nginx type分别为：</p>
<pre>typedef intptr_t ngx_int_t;
typedef uintptr_t ngx_uint_t;
typedef intptr_t ngx_flag_t;</pre>
<p>具体定义请参看core/ngx_config.h。关于intptr_t和uintptr_t请参考C99中的<a href="http://linux.die.net/include/stdint.h" rel="external nofollow noreferrer">stdint.h</a>或<a href="http://linux.die.net/man/3/intptr_t" rel="external nofollow noreferrer">http://linux.die.net/man/3/intptr_t</a>。</p>
<h2>定义指令</h2>
<p>一个Nginx模块往往接收一至多个指令，echo模块接收一个指令&ldquo;echo&rdquo;。Nginx模块使用一个ngx_command_t数组表示模块所能接收的所有模块，其中每一个元素表示一个条指令。ngx_command_t是ngx_command_s的一个别称（Nginx习惯于使用&ldquo;_s&rdquo;后缀命名结构体，然后typedef一个同名&ldquo;_t&rdquo;后缀名称作为此结构体的类型名），ngx_command_s定义在core/ngx_config_file.h中：</p>
<pre>struct ngx_command_s {
　　ngx_str_t name;
　　ngx_uint_t type;
　　char *(*set)(ngx_conf_t *cf, ngx_command_t *cmd, void *conf);
　　ngx_uint_t conf;
　　ngx_uint_t offset;
　　void *post;
};</pre>
<p>其中name是词条指令的名称，type使用掩码标志位方式配置指令参数，相关可用type定义在core/ngx_config_file.h中：</p>
<pre>#define NGX_CONF_NOARGS 0x00000001
#define NGX_CONF_TAKE1 0x00000002
#define NGX_CONF_TAKE2 0x00000004
#define NGX_CONF_TAKE3 0x00000008
#define NGX_CONF_TAKE4 0x00000010
#define NGX_CONF_TAKE5 0x00000020
#define NGX_CONF_TAKE6 0x00000040
#define NGX_CONF_TAKE7 0x00000080
#define NGX_CONF_MAX_ARGS 8
#define NGX_CONF_TAKE12 (NGX_CONF_TAKE1|NGX_CONF_TAKE2)
#define NGX_CONF_TAKE13 (NGX_CONF_TAKE1|NGX_CONF_TAKE3)
#define NGX_CONF_TAKE23 (NGX_CONF_TAKE2|NGX_CONF_TAKE3)
#define NGX_CONF_TAKE123 (NGX_CONF_TAKE1|NGX_CONF_TAKE2|NGX_CONF_TAKE3)
#define NGX_CONF_TAKE1234 (NGX_CONF_TAKE1|NGX_CONF_TAKE2|NGX_CONF_TAKE3|NGX_CONF_TAKE4)
#define NGX_CONF_ARGS_NUMBER 0x000000ff
#define NGX_CONF_BLOCK 0x00000100
#define NGX_CONF_FLAG 0x00000200
#define NGX_CONF_ANY 0x00000400
#define NGX_CONF_1MORE 0x00000800
#define NGX_CONF_2MORE 0x00001000
#define NGX_CONF_MULTI 0x00002000</pre>
<p>其中NGX_CONF_NOARGS表示此指令不接受参数，NGX_CON F_TAKE1-7表示精确接收1-7个，NGX_CONF_TAKE12表示接受1或2个参数，NGX_CONF_1MORE表示至少一个参数，NGX_CONF_FLAG表示接受&ldquo;on|off&rdquo;&hellip;&hellip;</p>
<p>set是一个函数指针，用于指定一个参数转化函数，这个函数一般是将配置文件中相关指令的参数转化成需要的格式并存入配置结构体。Nginx预定义了一些转换函数，可以方便我们调用，这些函数定义在core/ngx_conf_file.h中，一般以&ldquo;_slot&rdquo;结尾，例如ngx_conf_set_flag_slot将&ldquo;on或off&rdquo;转换为&ldquo;1或0&rdquo;，再如ngx_conf_set_str_slot将裸字符串转化为ngx_str_t。</p>
<p>conf用于指定Nginx相应配置文件内存其实地址，一般可以通过内置常量指定，如NGX_HTTP_LOC_CONF_OFFSET，offset指定此条指令的参数的偏移量。</p>
<p>下面是echo模块的指令定义：</p>
<pre>static ngx_command_t ngx_http_echo_commands[] = {
　　{ ngx_string("echo"),
　　NGX_HTTP_LOC_CONF|NGX_CONF_TAKE1,
　　ngx_http_echo,
　　NGX_HTTP_LOC_CONF_OFFSET,
　　offsetof(ngx_http_echo_loc_conf_t, ed),
　　NULL 　　},
　　ngx_null_command
};</pre>
<p>指令数组的命名规则为ngx_http_[module-name]_commands，注意数组最后一个元素要是ngx_null_command结束。</p>
<p>参数转化函数的代码为：</p>
<pre>static char *ngx_http_echo(ngx_conf_t *cf, ngx_command_t *cmd, void *conf){
　　ngx_http_core_loc_conf_t *clcf;
　　clcf = ngx_http_conf_get_module_loc_conf(cf, ngx_http_core_module);
　　clcf-&gt;handler = ngx_http_echo_handler;
　　ngx_conf_set_str_slot(cf,cmd,conf);
　　return NGX_CONF_OK;
}</pre>
<p>这个函数除了调用ngx_conf_set_str_slot转化echo指令的参数外，还将修改了核心模块配置（也就是这个location的配置），将其handler替换为我们编写的handler：ngx_http_echo_handler。这样就屏蔽了此location的默认handler，使用ngx_http_echo_handler产生HTTP响应。</p>
<h2>创建合并配置信息</h2>
<p>下一步是定义模块Context。</p>
<p>这里首先需要定义一个ngx_http_module_t类型的结构体变量，命名规则为ngx_http_[module-name]_module_ctx，这个结构主要用于定义各个Hook函数。下面是echo模块的context结构：</p>
<pre>static ngx_http_module_t ngx_http_echo_module_ctx = {
　　NULL, /* preconfiguration */
　　NULL, /* postconfiguration */
　　NULL, /* create main configuration */
　　NULL, /* init main configuration */
　　NULL, /* create server configuration */
　　NULL, /* merge server configuration */
　　ngx_http_echo_create_loc_conf, /* create location configration */
　　ngx_http_echo_merge_loc_conf /* merge location configration */
};</pre>
<p>可以看到一共有8个Hook注入点，分别会在不同时刻被Nginx调用，由于我们的模块仅仅用于location域，这里将不需要的注入点设为NULL即可。其中create_loc_conf用于初始化一个配置结构体，如为配置结构体分配内存等工作；merge_loc_conf用于将其父block的配置信息合并到此结构体中，也就是实现配置的继承。这两个函数会被Nginx自动调用。注意这里的命名规则：ngx_http_[module-name]_[create|merge]_[main|srv|loc]_conf。</p>
<p>下面是echo模块这个两个函数的代码：</p>
<pre>static void *ngx_http_echo_create_loc_conf(ngx_conf_t *cf){
    ngx_http_echo_loc_conf_t *conf;
　　conf = ngx_pcalloc(cf-&gt;pool, sizeof(ngx_http_echo_loc_conf_t));
　　if (conf == NULL) {
　　　　return NGX_CONF_ERROR;
　　}
　　conf-&gt;ed.len = 0;
　　conf-&gt;ed.data = NULL;
　　return conf;
}
static char *ngx_http_echo_merge_loc_conf(ngx_conf_t *cf, void *parent, void *child){
　　ngx_http_echo_loc_conf_t *prev = parent;
　　ngx_http_echo_loc_conf_t *conf = child;
　　ngx_conf_merge_str_value(conf-&gt;ed, prev-&gt;ed, "");
　　return NGX_CONF_OK;
}</pre>
<p>其中ngx_pcalloc用于在Nginx内存池中分配一块空间，是pcalloc的一个包装。使用ngx_pcalloc分配的内存空间不必手工free，Nginx会自行管理，在适当是否释放。</p>
<p>create_loc_conf新建一个ngx_http_echo_loc_conf_t，分配内存，并初始化其中的数据，然后返回这个结构的指针；merge_loc_conf将父block域的配置信息合并到create_loc_conf新建的配置结构体中。</p>
<p>其中ngx_conf_merge_str_value不是一个函数，而是一个宏，其定义在core/ngx_conf_file.h中：</p>
<pre>#define ngx_conf_merge_str_value(conf, prev, default) 　　if (conf.data == NULL) { 　　　　if (prev.data) { 　　　　　　conf.len = prev.len; 　　　　　　conf.data = prev.data; 　　　　} else { 　　　　　　conf.len = sizeof(default) - 1; 　　　　　　conf.data = (u_char *) default; } }</pre>
<p>同时可以看到，core/ngx_conf_file.h还定义了很多merge value的宏用于merge各种数据。它们的行为比较相似：使用prev填充conf，如果prev的数据为空则使用default填充。</p>
<h2>编写Handler</h2>
<p>下面的工作是编写handler。handler可以说是模块中真正干活的代码，它主要有以下四项职责：</p>
<p>读入模块配置。</p>
<p>处理功能业务。</p>
<p>产生HTTP header。</p>
<p>产生HTTP body。</p>
<p>下面先贴出echo模块的代码，然后通过分析代码的方式介绍如何实现这四步。这一块的代码比较复杂：</p>
<pre>static ngx_int_t ngx_http_echo_handler(ngx_http_request_t *r){
　　ngx_int_t rc;
　　ngx_buf_t *b;
　　ngx_chain_t out;
　　ngx_http_echo_loc_conf_t *elcf;
　　elcf = ngx_http_get_module_loc_conf(r, ngx_http_echo_module);
　　if(!(r-&gt;method &amp; (NGX_HTTP_HEAD|NGX_HTTP_GET|NGX_HTTP_POST))){
　　　　return NGX_HTTP_NOT_ALLOWED;
　　}
　　r-&gt;headers_out.content_type.len = sizeof("text/html") - 1;
　　r-&gt;headers_out.content_type.data = (u_char *) "text/html";
　　r-&gt;headers_out.status = NGX_HTTP_OK;
　　r-&gt;headers_out.content_length_n = elcf-&gt;ed.len;
　　if(r-&gt;method == NGX_HTTP_HEAD){
　　　　rc = ngx_http_send_header(r);
　　　　if(rc != NGX_OK){
　　　　　　return rc;
　　　　}
　　}
　　b = ngx_pcalloc(r-&gt;pool, sizeof(ngx_buf_t));
　　if(b == NULL){
　　　　ngx_log_error(NGX_LOG_ERR, r-&gt;connection-&gt;log, 0, "Failed to allocate response buffer.");
　　　　return NGX_HTTP_INTERNAL_SERVER_ERROR;
　　}
　　out.buf = b;
　　out.next = NULL;
　　b-&gt;pos = elcf-&gt;ed.data;
　　b-&gt;last = elcf-&gt;ed.data + (elcf-&gt;ed.len);
　　b-&gt;memory = 1;
　　b-&gt;last_buf = 1;
　　rc = ngx_http_send_header(r);
　　if(rc != NGX_OK){
　　　　return rc;
　　}
　　return ngx_http_output_filter(r, &amp;out);
}</pre>
<p>handler会接收一个ngx_http_request_t指针类型的参数，这个参数指向一个ngx_http_request_t结构体，此结构体存储了这次HTTP请求的一些信息，这个结构定义在http/ngx_http_request.h中：</p>
<pre>struct ngx_http_request_s {
　　uint32_t signature; /* "HTTP" */
　　ngx_connection_t *connection;
　　void **ctx;
　　void **main_conf;
　　void **srv_conf;
　　void **loc_conf;
　　ngx_http_event_handler_pt read_event_handler;
　　ngx_http_event_handler_pt write_event_handler;
　　#if (NGX_HTTP_CACHE)
　　ngx_http_cache_t *cache;
　　#endif
　　ngx_http_upstream_t *upstream;
　　ngx_array_t *upstream_states;
　　/* of ngx_http_upstream_state_t */
　　ngx_pool_t *pool;
　　ngx_buf_t *header_in;
　　ngx_http_headers_in_t headers_in;
　　ngx_http_headers_out_t headers_out;
　　ngx_http_request_body_t *request_body;
　　time_t lingering_time;
　　time_t start_sec;
　　ngx_msec_t start_msec;
　　ngx_uint_t method;
　　ngx_uint_t http_version;
　　ngx_str_t request_line;
　　ngx_str_t uri;
　　ngx_str_t args;
　　ngx_str_t exten;
　　ngx_str_t unparsed_uri;
　　ngx_str_t method_name;
　　ngx_str_t http_protocol;
　　ngx_chain_t *out;
　　ngx_http_request_t *main;
　　ngx_http_request_t *parent;
　　ngx_http_postponed_request_t *postponed;
　　ngx_http_post_subrequest_t *post_subrequest;
　　ngx_http_posted_request_t *posted_requests;
　　ngx_http_virtual_names_t *virtual_names;
　　ngx_int_t phase_handler;
　　ngx_http_handler_pt content_handler;
　　ngx_uint_t access_code;
　　ngx_http_variable_value_t *variables;
　　/* ... */
}</pre>
<p>由于ngx_http_request_s定义比较长，这里我只截取了一部分。可以看到里面有诸如uri，args和request_body等HTTP常用信息。这里需要特别注意的几个字段是headers_in、headers_out和chain，它们分别表示request header、response header和输出数据缓冲区链表（缓冲区链表是Nginx I/O中的重要内容，后面会单独介绍）。</p>
<p>第一步是获取模块配置信息，这一块只要简单使用ngx_http_get_module_loc_conf就可以了。</p>
<p>第二步是功能逻辑，因为echo模块非常简单，只是简单输出一个字符串，所以这里没有功能逻辑代码。</p>
<p>第三步是设置response header。Header内容可以通过填充headers_out实现，我们这里只设置了Content-type和Content-length等基本内容，ngx_http_headers_out_t定义了所有可以设置的HTTP Response Header信息：</p>
<pre>typedef struct {
　　ngx_list_t headers;
　　ngx_uint_t status;
　　ngx_str_t status_line;
　　ngx_table_elt_t *server;
　　ngx_table_elt_t *date;
　　ngx_table_elt_t *content_length;
　　ngx_table_elt_t *content_encoding;
　　ngx_table_elt_t *location;
　　ngx_table_elt_t *refresh;
　　ngx_table_elt_t *last_modified;
　　ngx_table_elt_t *content_range;
　　ngx_table_elt_t *accept_ranges;
　　ngx_table_elt_t *www_authenticate;
　　ngx_table_elt_t *expires;
　　ngx_table_elt_t *etag;
　　ngx_str_t *override_charset;
　　size_t content_type_len;
　　ngx_str_t content_type;
　　ngx_str_t charset;
　　u_char *content_type_lowcase;
　　ngx_uint_t content_type_hash;
　　ngx_array_t cache_control;
　　off_t content_length_n;
　　time_t date_time;
　　time_t last_modified_time;
} ngx_http_headers_out_t;</pre>
<p>这里并不包含所有HTTP头信息，如果需要可以使用agentzh（春来）开发的Nginx模块<a href="http://wiki.nginx.org/HttpHeadersMoreModule" rel="external nofollow noreferrer">HttpHeadersMore</a>在指令中指定更多的Header头信息。</p>
<p>设置好头信息后使用ngx_http_send_header就可以将头信息输出，ngx_http_send_header接受一个ngx_http_request_t类型的参数。</p>
<p>第四步也是最重要的一步是输出Response body。这里首先要了解Nginx的I/O机制，Nginx允许handler一次产生一组输出，可以产生多次，Nginx将输出组织成一个单链表结构，链表中的每个节点是一个chain_t，定义在core/ngx_buf.h：</p>
<pre>struct ngx_chain_s {
　　ngx_buf_t *buf;
　　ngx_chain_t *next;
};</pre>
<p>其中ngx_chain_t是ngx_chain_s的别名，buf为某个数据缓冲区的指针，next指向下一个链表节点，可以看到这是一个非常简单的链表。ngx_buf_t的定义比较长而且很复杂，这里就不贴出来了，请自行参考core/ngx_buf.h。ngx_but_t中比较重要的是pos和last，分别表示要缓冲区数据在内存中的起始地址和结尾地址，这里我们将配置中字符串传进去，last_buf是一个位域，设为1表示此缓冲区是链表中最后一个元素，为0表示后面还有元素。因为我们只有一组数据，所以缓冲区链表中只有一个节点，如果需要输入多组数据可将各组数据放入不同缓冲区后插入到链表。下图展示了Nginx缓冲链表的结构：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvZy5jb2RpbmdsYWJzLm9yZy91cGxvYWRzL3BpY3R1cmVzL2ludHJvLW9mLW5naW54LW1vZHVsZS1kZXZlbG9wbWVudC8zLnBuZw==.jpg" /></p>
<p>缓冲数据准备好后，用ngx_http_output_filter就可以输出了（会送到filter进行各种过滤处理）。ngx_http_output_filter的第一个参数为ngx_http_request_t结构，第二个为输出链表的起始地址&amp;out。ngx_http_out_put_filter会遍历链表，输出所有数据。</p>
<p>以上就是handler的所有工作，请对照描述理解上面贴出的handler代码。</p>
<h2>组合Nginx Module</h2>
<p>上面完成了Nginx模块各种组件的开发下面就是将这些组合起来了。一个Nginx模块被定义为一个ngx_module_t结构，这个结构的字段很多，不过开头和结尾若干字段一般可以通过Nginx内置的宏去填充，下面是我们echo模块的模块主体定义：</p>
<pre>ngx_module_t ngx_http_echo_module = {
　　NGX_MODULE_V1,
　　&amp;ngx_http_echo_module_ctx, /* module context */
　　ngx_http_echo_commands, /* module directives */
　　NGX_HTTP_MODULE, /* module type */
　　NULL, /* init master */
　　NULL, /* init module */
　　NULL, /* init process */
　　NULL, /* init thread */
　　NULL, /* exit thread */
　　NULL, /* exit process */
　　NULL, /* exit master */
　　NGX_MODULE_V1_PADDING
};</pre>
<p>开头和结尾分别用NGX_MODULE_V1和NGX_MODULE_V1_PADDING 填充了若干字段，就不去深究了。这里主要需要填入的信息从上到下以依次为context、指令数组、模块类型以及若干特定事件的回调处理函数（不需要可以置为NULL），其中内容还是比较好理解的，注意我们的echo是一个HTTP模块，所以这里类型是NGX_HTTP_MODULE，其它可用类型还有NGX_EVENT_MODULE（事件处理模块）和NGX_MAIL_MODULE（邮件模块）。</p>
<p>这样，整个echo模块就写好了，下面给出echo模块的完整代码：</p>
<p>ngx_http_echo_module.c</p>
<pre>#include &lt;ngx_config.h&gt;
#include &lt;ngx_core.h&gt;
#include &lt;ngx_http.h&gt;

typedef struct {
    ngx_str_t  ed;
} ngx_http_echo_loc_conf_t;
static char *ngx_http_echo(ngx_conf_t *cf, ngx_command_t *cmd, void *conf);
static void *ngx_http_echo_create_loc_conf(ngx_conf_t *cf);
static char *ngx_http_echo_merge_loc_conf(ngx_conf_t *cf, void *parent, void *child);
/* Directives */
static ngx_command_t  ngx_http_echo_commands[] = {
    { ngx_string("echo"),
        NGX_HTTP_LOC_CONF|NGX_CONF_TAKE1,
        ngx_http_echo,
        NGX_HTTP_LOC_CONF_OFFSET,
        offsetof(ngx_http_echo_loc_conf_t, ed),
        NULL },
        ngx_null_command
};
/* Http context of the module */
static ngx_http_module_t  ngx_http_echo_module_ctx = {
    NULL,                                  /* preconfiguration */
    NULL,                                  /* postconfiguration */
    NULL,                                  /* create main configuration */
    NULL,                                  /* init main configuration */
    NULL,                                  /* create server configuration */
    NULL,                                  /* merge server configuration */
    ngx_http_echo_create_loc_conf,         /* create location configration */
    ngx_http_echo_merge_loc_conf           /* merge location configration */
};
/* Module */
ngx_module_t  ngx_http_echo_module = {
    NGX_MODULE_V1,
    &amp;ngx_http_echo_module_ctx,             /* module context */
    ngx_http_echo_commands,                /* module directives */
    NGX_HTTP_MODULE,                       /* module type */
    NULL,                                  /* init master */
    NULL,                                  /* init module */
    NULL,                                  /* init process */
    NULL,                                  /* init thread */
    NULL,                                  /* exit thread */
    NULL,                                  /* exit process */
    NULL,                                  /* exit master */
    NGX_MODULE_V1_PADDING
};
/* Handler function */
static ngx_int_t ngx_http_echo_handler(ngx_http_request_t *r){
    ngx_int_t rc;
    ngx_buf_t *b;
    ngx_chain_t out;
    ngx_http_echo_loc_conf_t *elcf;
    elcf = ngx_http_get_module_loc_conf(r, ngx_http_echo_module);
    if(!(r-&gt;method &amp; (NGX_HTTP_HEAD|NGX_HTTP_GET|NGX_HTTP_POST))){
        return NGX_HTTP_NOT_ALLOWED;
    }
    r-&gt;headers_out.content_type.len = sizeof("text/html") - 1;
    r-&gt;headers_out.content_type.data = (u_char *) "text/html";
    r-&gt;headers_out.status = NGX_HTTP_OK;
    r-&gt;headers_out.content_length_n = elcf-&gt;ed.len;
    if(r-&gt;method == NGX_HTTP_HEAD){
        rc = ngx_http_send_header(r);
        if(rc != NGX_OK){
            return rc;
        }
    }
    b = ngx_pcalloc(r-&gt;pool, sizeof(ngx_buf_t));
    if(b == NULL){
        ngx_log_error(NGX_LOG_ERR, r-&gt;connection-&gt;log, 0, "Failed to allocate response buffer.");
        return NGX_HTTP_INTERNAL_SERVER_ERROR;
    }
    out.buf = b;
    out.next = NULL;
    b-&gt;pos = elcf-&gt;ed.data;
    b-&gt;last = elcf-&gt;ed.data + (elcf-&gt;ed.len);
    b-&gt;memory = 1;
    b-&gt;last_buf = 1;
    rc = ngx_http_send_header(r);
    if(rc != NGX_OK){
        return rc;
    }
    return ngx_http_output_filter(r, &amp;out);
}
static char *ngx_http_echo(ngx_conf_t *cf, ngx_command_t *cmd, void *conf){
    ngx_http_core_loc_conf_t  *clcf;
    clcf = ngx_http_conf_get_module_loc_conf(cf, ngx_http_core_module);
    clcf-&gt;handler = ngx_http_echo_handler;
    ngx_conf_set_str_slot(cf,cmd,conf);
    return NGX_CONF_OK;
}
static void *ngx_http_echo_create_loc_conf(ngx_conf_t *cf){
    ngx_http_echo_loc_conf_t  *conf;
    conf = ngx_pcalloc(cf-&gt;pool, sizeof(ngx_http_echo_loc_conf_t));
    if (conf == NULL) {
        return NGX_CONF_ERROR;
    }
    conf-&gt;ed.len = 0;
    conf-&gt;ed.data = NULL;
    return conf;
}
static char *ngx_http_echo_merge_loc_conf(ngx_conf_t *cf, void *parent, void *child){
    ngx_http_echo_loc_conf_t *prev = parent;
    ngx_http_echo_loc_conf_t *conf = child;
    ngx_conf_merge_str_value(conf-&gt;ed, prev-&gt;ed, "");
    return NGX_CONF_OK;
}</pre>

<h1>Nginx模块的安装(如果之前nginx的安装是跟我上一个教程做的话目录可以照搬,否则需要改成你们nginx自己的安装目录和源码目录)</h1>
<p>我的nginx源码目录在/usr/local/src/nginx-1.4.2，安装目录在/usr/local/nginx</p>
<p>Nginx不支持动态链接模块，所以安装模块需要将模块代码与Nginx源代码进行重新编译。安装模块的步骤如下：</p>
<p>1、编写模块config文件，这个文件需要放在和模块源代码文件放在同一目录下。文件内容如下：</p>
<pre>ngx_addon_name=模块完整名称
HTTP_MODULES="$HTTP_MODULES 模块完整名称"
NGX_ADDON_SRCS="$NGX_ADDON_SRCS $ngx_addon_dir/源代码文件名"</pre>
<p>2、查看nginx编译安装时的命令，安装了哪些模块</p>
<pre>sudo /usr/local/nginx/nginx -V</pre>
<p>3、进入Nginx源代码目录，使用下面命令编译生成可执行文件</p>
<pre>cd /usr/local/src/nginx-1.4.2sudo ./configure --prefix=安装目录 --add-module=模块源代码文件目录 --之前安装nginx的配置参数
sudo makesudo cp /usr/local/src/nginx-1.4.2/objs/nginx /usr/local/nginx/nginx </pre>
<p>这样就完成了</p>
<p>举个详细的例子，模块源码就是上面的,直接复制即可,我的源代码文件放在~/nginx/ngx_http_echo_module下，我的config文件为：</p>
<pre>ngx_addon_name=ngx_http_echo_module
HTTP_MODULES="$HTTP_MODULES ngx_http_echo_module"
NGX_ADDON_SRCS="$NGX_ADDON_SRCS $ngx_addon_dir/ngx_http_echo_module.c</pre>
<p>要添加的模块的目录结构如下:</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY2MjU5Mi8yMDE1MTAvNjYyNTkyLTIwMTUxMDIwMTgyNDI5OTI3LTE2ODU4MTM1NTkucG5n.jpg" /></p>
<p>首先查看nginx编译时的配置参数</p>
<pre>sudo /usr/local/nginx/nginx -V</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY2MjU5Mi8yMDE1MTAvNjYyNTkyLTIwMTUxMDIwMTc0NjE3MTc3LTg0MjM3NTcyMi5wbmc=.jpg" /></p>
<p>然后进入源码nginx的源码目录编译,只需在原来的编译参数后加模块参数就行了：(注意目录)</p>
<pre>cd /usr/local/src/nginx-1.4.2sudo ./configure --sbin-path=/usr/local/nginx/nginx --conf-path=/usr/local/nginx/nginx.conf --pid-path=/usr/local/nginx/nginx.pid --prefix=/usr/local/nginx --with-http_ssl_module <em><strong>--add-module=/home/wj/nginx/ngx_http_echo_module</strong></em></pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY2MjU5Mi8yMDE1MTAvNjYyNTkyLTIwMTUxMDIwMTgyNjAxODk1LTE5NDYyOTA4NC5wbmc=.jpg" /></p>
<p>在configure的时候我们可以看到模块被configure文件发现了</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY2MjU5Mi8yMDE1MTAvNjYyNTkyLTIwMTUxMDIwMTgyNzI1ODk1LTExNjA0MTM0MTAucG5n.jpg" /></p>
<p>configure完毕,开始make编译(仍在nginx源码目录):</p>
<pre>sudo make</pre>
<p>make完毕,千万不要sudo make install了,很多参考文档都是install,然并卵,install之后在改配置文件的时候还是会有错,而且一旦configure的时候参数把依赖库也写进去的话你就又把那些已经编译过的依赖又编译了一遍,耗时又浪费系统资源,所以,在安装nginx的时候configure时可以先不指定依赖,参数只写它的安装目录,如果没有报错说明你的系统已经有这些依赖了.我前面在安装nginx前特定下了pcre、zlib、openssl，还编译安装，后来发现这些步骤根本就是白做了，因为系统已经有这些依赖了。希望安装的可以引以为戒。在make之后已经生成了新的nginx可执行文件,在/usr/local/src/nginx-1.4.2/objs下,</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY2MjU5Mi8yMDE1MTAvNjYyNTkyLTIwMTUxMDIwMTgwMDEyMjI0LTExODE5MDM0OTIucG5n.jpg" /></p>
<p>此时的nginx是已经重新编译过得了，可以直接拷贝到nginx的安装目录下。</p>
<pre>sudo mv /usr/local/nginx/nginx /usr/local/nginx/nginx.oldsudo /usr/local/nginx/nginx -s stop(如果你的nginx开着的话，执行这步)
sudo cp /usr/local/src/nginx-1.4.2/objs/nginx /usr/local/nginx/nginx</pre>
<p>此时，基本上大功告成，你的新模块已经编译进了nginx中。</p>
<p>下面测试一下，修改nginx.conf配置文件，增加以下一项配置：</p>
<pre>location /echo {
　　echo "This is my first nginx module!!!";
}</pre>
<p>然后开启nginx用curl测试一下：</p>
<pre>sudo /usr/local/nginx/nginx
curl -i http://localhost/echo</pre>
<p>结果如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY2MjU5Mi8yMDE1MTAvNjYyNTkyLTIwMTUxMDIwMTgzMjEwMzAyLTE4NDg1ODIzNzgucG5n.jpg" />　　</p>
<p>这个nginx模块的开发流程到此结束！</p>
<p>下面再看看nginx加载多模块的流程。</p>
<p>假如已经有开发好的2个模块：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY2MjU5Mi8yMDE1MTAvNjYyNTkyLTIwMTUxMDIwMTg0MTU5MDIwLTEyNjc1ODY4NjQucG5n.jpg" /></p>
<p>配置configure文件：</p>
<pre> sudo ./configure --sbin-path=/usr/local/nginx/nginx --conf-path=/usr/local/nginx/nginx.conf --pid-path=/usr/local/nginx/nginx.pid --prefix=/usr/local/nginx --with-http_ssl_module <em><strong>--add-module=/home/wj/nginx/ngx_http_echo_module --add-module=/home/wj/nginx/ngx_http_hello_world_module</strong></em></pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY2MjU5Mi8yMDE1MTAvNjYyNTkyLTIwMTUxMDIwMTg0MzA2MTE0LTE1ODgwMzkxMDYucG5n.jpg" /></p>
<p>configure文件发现了2个开发模块：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY2MjU5Mi8yMDE1MTAvNjYyNTkyLTIwMTUxMDIwMTg0MzMwOTI3LTg3Mzk2OTE2Mi5wbmc=.jpg" /></p>
<p>然后开始编译：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY2MjU5Mi8yMDE1MTAvNjYyNTkyLTIwMTUxMDIwMTg0MDM4NzU1LTE2NTQ3ODg3NDAucG5n.jpg" /></p>
<p>生成了可执行文件：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY2MjU5Mi8yMDE1MTAvNjYyNTkyLTIwMTUxMDIwMTg0NTM0NzM5LTQ2NzAxNzk2Mi5wbmc=.jpg" /></p>
<p>拷贝至nginx安装目录：</p>
<pre>sudo /usr/local/nginx/nginx -s stop（拷贝时若提示文本文件忙，可以先停掉nginx）sudo cp ./objs/nginx /usr/local/nginx/nginx</pre>
<p>在nginx.conf配置文件中添加location</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY2MjU5Mi8yMDE1MTAvNjYyNTkyLTIwMTUxMDIwMTg0OTU3MzY0LTEyMjUxNzkzMTQucG5n.jpg" /></p>
<p>然后开启nginx用curl测试一下：</p>
<pre>sudo /usr/local/nginx/nginxcurl -i http://localhost/hello_world
curl -i http://localhost/echo</pre>
<p>结果如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY2MjU5Mi8yMDE1MTAvNjYyNTkyLTIwMTUxMDIwMTg1MTUyNzA4LTE4NDUxODczMTcucG5n.jpg" /></p>
<p>浏览器端：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY2MjU5Mi8yMDE1MTAvNjYyNTkyLTIwMTUxMDIwMTg1OTI5NTY3LTEzMTYyMTYwOTQucG5n.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY2MjU5Mi8yMDE1MTAvNjYyNTkyLTIwMTUxMDIwMTg1OTU2NjkyLTE0MTY1NDUyNzcucG5n.jpg" /></p>
<p>单模块多模块的编译使用都已经讲完了，下面总结一下：</p>
<p>1、在安装nginx的时候，如果你在configure的时候参数没有加pcre、zlib、openssl等依赖也没报错那就不需要编译安装这些依赖</p>
<p>2、如果安装nginx时，configure报错了，说明你的系统缺少这些依赖，你还是老老实实的先编译安装这些库，再在configure的配置参数中加入这些库，并且在以后的模块开发中，每次加入模块时，都要在configure配置参数中加入这些库。</p>
<p>3、在编译完新模块后，你可以选择install ，也可以选择不install，install会把你所有已经编译好的文件都覆盖安装一遍，很费时间资源，而且我在install之后还遇到了莫名其妙问题。所以，可以在make之后，直接把编译好的nginx二进制文件放到nginx安装目录下，直接使用。</p>
<p>在安装编译时有谁遇到了问题可以评论，我一直认为学生自学没有笨的学生只有垃圾的文档，所以在每次做完一个东西我都会写下来，帮助自己忘得时候快速回忆，也帮助初学者快速上手，有写的不对的地方还恳请高手指正</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 23:58:16 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>linux下nginx模块开发入门的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPd5jyM.html" rel="bookmark">Nginx模块开发入门（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 Nginx是当前最流行的HTTP Server之一,根据W3Techs的统计,目前世界排名(根据Alexa)前100万的网站中,Nginx的占有率为6.8%.与Apache相比,Nginx在高并发情况下具有巨大的性能优势. Nginx属于典型的微内核设计,其内核非常简洁和优雅,同时具有非常高的可扩展性.Nginx最初仅仅主要被用于做反向代理,后来随着HTTP核心的成熟和各种HTTP扩展模块的丰富,Nginx越来越多被用来取代Apache而单独承担HTTP Server的责任,例如目前淘宝内			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Amx8g4.html" rel="bookmark">Nginx模块开发入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 Nginx是当前最流行的HTTP Server之一,根据W3Techs的统计,目前世界排名(根据Alexa)前100万的网站中,Nginx的占有率为6.8%.与Apache相比,Nginx在高并发情况下具有巨大的性能优势. Nginx属于典型的微内核设计,其内核非常简洁和优雅,同时具有非常高的可扩展性.Nginx最初仅仅主要被用于做反向代理,后来随着HTTP核心的成熟和各种HTTP扩展模块的丰富,Nginx越来越多被用来取代Apache而单独承担HTTP Server的责任,例如目前淘宝内			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MP8gnPM.html" rel="bookmark">Nginx模块开发入门&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 Nginx是当前最流行的HTTP Server之一,根据W3Techs的统计,目前世界排名(根据Alexa)前100万的网站中,Nginx的占有率为6.8%.与Apache相比,Nginx在高并发情况下具有巨大的性能优势. Nginx属于典型的微内核设计,其内核非常简洁和优雅,同时具有非常高的可扩展性.Nginx最初仅仅主要被用于做反向代理,后来随着HTTP核心的成熟和各种HTTP扩展模块的丰富,Nginx越来越多被用来取代Apache而单独承担HTTP Server的责任,例如目前淘宝内			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MENY2g0.html" rel="bookmark">&lbrack;转&rsqb; Nginx模块开发入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 Nginx是当前最流行的HTTP Server之一,根据W3Techs的统计,目前世界排名(根据Alexa)前100万的网站中,Nginx的占有率为6.8%.与Apache相比,Nginx在高并发情况下具有巨大的性能优势. Nginx属于典型的微内核设计,其内核非常简洁和优雅,同时具有非常高的可扩展性.Nginx最初仅仅主要被用于做反向代理,后来随着HTTP核 心的成熟和各种HTTP扩展模块的丰富,Nginx越来越多被用来取代Apache而单独承担HTTP Server的责任,例如目前淘宝			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AKDpz0.html" rel="bookmark">FW&colon;  Nginx模块开发入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 Nginx是当前最流行的HTTP Server之一,根据W3Techs的统计,目前世界排名(根据Alexa)前100万的网站中,Nginx的占有率为6.8%.与Apache相比,Nginx在高并发情况下具有巨大的性能优势. Nginx属于典型的微内核设计,其内核非常简洁和优雅,同时具有非常高的可扩展性.Nginx最初仅仅主要被用于做反向代理,后来随着HTTP核心的成熟和各种HTTP扩展模块的丰富,Nginx越来越多被用来取代Apache而单独承担HTTP Server的责任,例如目前淘宝内			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wYZq1M.html" rel="bookmark">nginx http模块开发入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				导语 本文对nginx http模块开发需要掌握的一些关键点进行了提炼,同时以开发一个简单的日志模块进行讲解,让nginx的初学者也能看完之后做到心里有谱.本文只是一个用作入门的概述. 目录 背景 主线 认识nginx http请求处理流程 日志模块开发准备 配置解析流程 挂载处理函数 获取日志数据 模块编译 完整源码 结尾 背景 网上已经有很多介绍nginx http模块开发入门的文章,但是大多以hello_word程序为例,简单讲解一下代码,看完之后可能只能够依葫芦画瓢,做不了其它事情,更不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lqdOE3.html" rel="bookmark">Linux下搭建PHP开发环境（LAMP）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				LAMP:Linux+Apache+Mysql/MariaDB+Perl/PHP/Python 安装方法如下: 注:Ubuntu下可使用sudo su 命名切换到root用户. 开始安装之前,先执行EZHTTP安装前的准备工作. 一.使用screen(可选) 由于编译安装Nginx Apache PHP MySQL等软件会花费比较长的时间,难免会出现由于网络意外中断而导致安装也中断了,所以为了避免此问题,可以使用screen来安装. screen的使用方法如下: 1.安装screen ubunt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoaAeD3.html" rel="bookmark">linux下nginx&comma;mysql&comma;php&lpar;lnmp&rpar;编译安装</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关闭SELINUX vi /etc/selinux/config #SELINUX=enforcing #注释掉 #SELINUXTYPE=targeted #注释掉 SELINUX=disabled #增加 :wq!  #保存退出 setenforce 0 #使配置立即生效 mysql 5.5.28安装 安装路径:/usr/local/mysql数据库路径:/usr/local/mysql/data/ mysql从5.5版本开始,不再使用./configure编译,而是使用cmake编译器,具			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38pxDZ3.html" rel="bookmark">NGINX模块开发 之 验证URL参数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者:邹祁峰 邮箱:[email protected] 博客:http://blog.csdn.net/qifengzou 日期:2014.05.26 16:45 转载请注明来自&quot;祁峰&quot;的CSDN博客 要求在浏览器地址栏中输入&quot;localhost/login?user=qifeng&amp;passwd=123456&quot;,并在浏览器上显示验证结果(Success 或 Failed).以下是在NGINX中添加一个LOGIN模块的整个处理过程. 1 修改配置 修改配置文件			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/L3rqE70.html" rel="bookmark" class="title">13&period;1-全栈Java笔记&colon;打飞机游戏实战项目&vert;AWT技术&vert;MyGameFrame</a>
					<div>
						简介和项目目标 通过游戏项目学习整个Java基础知识体系,我们做了精心的设计,让每一章知识都能获得应用. 比如:多线程用来实现动画效果.容器实现对于多发炮弹的存取和处理.常用类等等的应用. 寓教于乐, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPN8xD3.html" rel="bookmark" class="title">使用RPM包安装、配置和拆卸MySQL</a>
					<div>
						通过rpm包安装.配置及卸载mysql的详细过程. 以MySQL-server-4.0.14-0.i386.rpm为例,放在/usr/src目录下 cd /usr/src rpm -ivh MySQL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/412V1YM.html" rel="bookmark" class="title">利用Servlet生成动态验证码</a>
					<div>
						先创建一个Servlet import javax.imageio.ImageIO; import javax.servlet.ServletException; import javax.servl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M68Dwy3.html" rel="bookmark" class="title">storm源码之storm代码结构【译】【转】</a>
					<div>
						[原]storm源码之storm代码结构[译] 说明:本文翻译自Storm在GitHub上的官方Wiki中提供的Storm代码结构描述一节Structure of the codebase,希望对正在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Om9DgM.html" rel="bookmark" class="title">listview的几个特别的属性讲解</a>
					<div>
						android ListView几个比较特别的属性 由于这两天在做listView的东西,所以整理出来一些我个人认为比较特别的属性,通过设置这样的属性可以做出更加美观的列表 首先是stackFromB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47pQbyM.html" rel="bookmark" class="title">程序媛计划&mdash;&mdash;python初级课时3～5</a>
					<div>
						产生1-10中的随机数: for 循环:所有可遍历对象都能用于for循环,如一个字符串. len(list),list中的元素类型可以各不相同:可以直接用下标对list元素赋值来更新列表 对字符串可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38Z6vRM.html" rel="bookmark" class="title">Python学习心得&mdash;&mdash;基础知识（二）</a>
					<div>
						列表(list)常见几种操作方式 1.在列表末尾插入内容——append a=[1,2,3,4,5,6] a.append(7) 结果:a=[1,2,3,4,5,6,7] 备注:列表内容可以为任何类型 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZAQ2q0.html" rel="bookmark" class="title">今天讲的是JQ 的动画效果</a>
					<div>
						老规矩,先贴代码 &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;meta charset=&quot;utf-8&quot;&gt; &lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgPqV80.html" rel="bookmark" class="title">【WCF】创建第一个WCF应用程序</a>
					<div>
						一.什么是WCF: Windows Communication Foundation(WCF)是由微软发展的一组数据通信的应用程序开发接口,也可以说是一套软件开发包.WCF合并了Web服务..net  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NagZJ3.html" rel="bookmark" class="title">Keil V5&period;1x命令&OpenCurlyDoubleQuote;Build Target&rdquo;重新编译所有文件</a>
					<div>
						网上的解决办法有多种,但不知道哪一种能对症,以下是我的解决方法:					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jn5bW0.html" rel="bookmark" class="title">VMware  vSphere 5&period;0高可用性和双机热备</a>
					<div>
						高可用性和双机热备是VMware vSphere 5.0最重要的一部分,高可用性并不是vSphere独有的,企业使用高可用性就是为了服务的连续性和数据的安全性.HA(High Availability ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgN1yO4.html" rel="bookmark" class="title">JavaScript push&lpar;&rpar; 方法</a>
					<div>
						JavaScript Array 对象 定义和用法 push() 方法可向数组的末尾添加一个或多个元素,并返回新的长度. 语法 arrayObject.push(newelement1,newelem ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRmZX3.html" rel="bookmark" class="title">衡阳高防服务器租用，服务器托管，机柜大带宽租用</a>
					<div>
						衡阳高防服务器租用,服务器托管,机柜大带宽租用 衡阳机房出口500G,30G--200G高防御, 开放UDP  开80端口  无视CC/UDP/SYN攻击! 全新配置戴尔R610,八核十六线程 湖南I ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPZkgm3.html" rel="bookmark" class="title">Flip Bits</a>
					<div>
						Determine the number of bits required to flip if you want to convert integer n to integer m. Notice  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KZmEyM.html" rel="bookmark" class="title">Apache Prefork、Worker和Event三種MPM分析</a>
					<div>
						三種MPM介紹 Apache 2.X  支持插入式並行處理模塊,稱爲多路處理模塊(MPM).在編譯apache時必須選擇也只能選擇一個MPM,對類UNIX系統,有幾個不同的MPM可供選擇,它們會影響到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZpoDlM.html" rel="bookmark" class="title">Double 数据保留两位小数一：五舍六入</a>
					<div>
						1 package com; 2 3 public class T2 { 4 5 public static void main(String[] args) { 6 7 System.out.pri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzBg7OM.html" rel="bookmark" class="title">加固你的TOMCAT，让TOMCAT在chroot的环境下运行</a>
					<div>
						众所周知,chroot下linux系统的一个安全机制,chroot是linux内核的一个系统调用,通过它,可以设定应用软件的运行环境,让应用软件运行在一个特定目录下,这样,即使应用软件有安全漏洞,被入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGDwna0.html" rel="bookmark" class="title">TFS 签入时，提示&OpenCurlyDoubleQuote;变更集注释策略 中的内部错误&hellip;&hellip;&rdquo;</a>
					<div>
						提示: 变更集注释策略 中的内部错误.加载 变更集注释策略 策略时出错(策略程序集&quot;Microsoft.TeamFoundation.PowerTools.CheckinPolicies.C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xXkqj0.html" rel="bookmark" class="title">删除C&colon;&bsol;Program Files &lpar;x86&rpar;&bsol;Common Files&bsol;baidu 等误装软件且正常模式删不掉的文件夹</a>
					<div>
						---------方法一-------- C:\Program Files\Common Files\Baidu\BaiduProtect\1.1.0.26打开以上路径找到反注册程序uninst.ex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXGelq4.html" rel="bookmark" class="title">一&period;jQuery源码解析之总体架构</a>
					<div>
						1 (function (window, undefined) { 2 //构建jQuery对象 3 var document = window.document, 4 navigator = win ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
